{-# OPTIONS --safe --without-K #-}

open import Data.Nat.Base using (ℕ)

module Regex.Properties.Core (α : ℕ) where

open import Regex α

open import Data.List.Base using ([]; _∷_)
open import Data.Sum.Base using (_⊎_; inj₁; inj₂)
open import Relation.Nullary.Negation.Core using (¬_)

-- Λ does not accept any string
end : ∀ as → ¬ Accepts Λ as
end [] ()
end (a ∷ as) p = end as p

split : ∀ {r₁ r₂} as → Accepts (r₁ + r₂) as → Accepts r₁ as ⊎ Accepts r₂ as
split [] (+ₗ p) = inj₁ p
split [] (+ᵣ p) = inj₂ p
split (a ∷ as) p = split as p

join₁ : ∀ {r₁ r₂} as → Accepts r₁ as → Accepts (r₁ + r₂) as
join₁ [] p = +ₗ p
join₁ (a ∷ as) p = join₁ as p

join₂ : ∀ {r₁ r₂} as → Accepts r₂ as → Accepts (r₁ + r₂) as
join₂ [] p = +ᵣ p
join₂ (a ∷ as) p = join₂ as p


